/******************************************************************

              Copyright 1990, 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Hiroko Sato (hiroko.sato@Sun.COM)
	  				     Sun Microsystems, Inc.
******************************************************************/
#ifndef lint
#ident  "@(#)HttProps.c	1.45    93/03/30 SMI"
#endif
#
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xol/OpenLook.h>
#include <Xol/RubberTile.h>
#include <Xol/RectButton.h>
#include <Xol/ScrollingL.h>
#include <Xol/Slider.h>
#include <Xol/TextField.h>
#include <Xol/ControlAre.h>
#include <Xol/StaticText.h>
#include <Xol/OblongButt.h>
#include <Xol/MenuButton.h>
#include <Xol/CheckBox.h>
#include <Xol/Exclusives.h>
#include <Xol/Nonexclusi.h>
#include <Xol/FCheckBox.h>
#include <Xol/BulletinBo.h>
#include <Xol/AbbrevMenu.h>
#include <Xol/PopupWindo.h>
#include <Xol/Caption.h>
#include <Xol/Notice.h>
#include <X11/Xlib.h>
#include <stdio.h>
#include <signal.h>
#include <locale.h>
#include "htt_icon"
#include "htt_icon_mask"
#ifdef	SVR4
#include <sys/systeminfo.h>
#include <netdb.h>
#include <libintl.h>
#include <sys/param.h>
#else
#include <sys/param.h>
#endif
#include "Htt.h"
#include "HttLkup.h"
#define Private static

#define MAXCOLUMNS 99
#define MAXROWS 99    

#ifndef standalone
extern
#endif
htt_t *htt ;

typedef struct _newsvalue_t {
    Bool is_statfeed_changed ;
    Bool is_prefeed_changed ;
    Bool is_attachedborder_changed ;
    Bool is_lucposition_changed ;
    Bool is_lucnavigation_changed ;
    Bool is_lucstyle_changed ;
    Bool is_interface_changed ;
    Bool is_movable_changed ;
    Bool is_saveunder_changed ;
    Bool is_norestart_changed ;
    Bool is_StylesupportList_changed ;

    int  statfeed ;
    int  prefeed ;
    int  prefeedback ;
    Bool attachedborder ;
    Bool lucposition ;
    Bool lucnavigation ;
    int  lucstyle ;
    Bool interface ;
    Bool movable ;
    Bool saveunder ;
    Bool norestart ;
    
} newvalue_t ;

newvalue_t *newvalue;

typedef struct _original_t {
    int  statfeed ;
    int  prefeed ;
    int  prefeedback ;
    Bool attachedborder ;
    Bool lucposition ;
    Bool lucnavigation ;
    int  lucstyle ;
    Bool interface ;
    Bool movable ;
    Bool saveunder ;
    Bool norestart ;
    Dimension nrows ;
    Dimension ncolumns ;
} original_t ;

original_t *original ;

typedef struct _XIMStyleRec {
    XIMStyle style;
    char           *name;
    OlListToken     token;
    OlListToken     token_exported;
    Bool            pvalid ;
    Bool            svalid ;
    int             priority ;
}               XIMStyleRec_t;

#define UNUSEDTOKEN (OlListToken) - 1
#define NULLTOKEN   (OlListToken) 0
#define Null (char *)NULL

Private int NXIMStyleExported = MAXSTYLES ;

Private
XIMStyleRec_t XIMStyleRec[MAXSTYLES] = {
    XIMPreeditCallbacks | XIMStatusArea,      Null, UNUSEDTOKEN, NULLTOKEN, True, True, 0,
    XIMPreeditCallbacks | XIMStatusNothing,   Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditCallbacks | XIMStatusNone,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditCallbacks | XIMStatusCallbacks, Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditPosition  | XIMStatusArea,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditPosition  | XIMStatusNothing,   Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditPosition  | XIMStatusNone,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditPosition  | XIMStatusCallbacks, Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditArea      | XIMStatusArea,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditArea      | XIMStatusNothing,   Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditArea      | XIMStatusNone,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditArea      | XIMStatusCallbacks, Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNothing   | XIMStatusArea,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNothing   | XIMStatusNothing,   Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNothing   | XIMStatusNone,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNothing   | XIMStatusCallbacks, Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNone      | XIMStatusArea,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNone      | XIMStatusNothing,   Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNone      | XIMStatusNone,      Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
    XIMPreeditNone      | XIMStatusCallbacks, Null, UNUSEDTOKEN, NULLTOKEN, True, True,  0,
};

/*#define MAXSTYLES (sizeof(XIMStyleRec)/sizeof(XIMStyleRec_t))*/
#define MAXMENUBUTTONS 3
#define MAXOPTIONS 4
#define MAXOVERS 3
#define MAXFEEDBACK	3
#define MAXLOOKUP 5
#define MAXBORDER  4
#define MAXINTERFACE 2
#define MAXPRE 5
#define MAXSTAT 4
#define MAXDIC 3

OlListToken (*appAdd) ();
void        (*appDelete) ();
void        (*appTouch) ();
void        (*appUpdate) ();
void        (*appView) ();

typedef struct _props {
    Widget          co;
    Widget          rb;
    String          heading;
}               props_t;
static props_t  props[3] ;
static Widget   preview, bb;
static char    *option[4] ;
static char    *feedback[3] ;
static char    *lookup[5] ;
static char    *attachborder[4] ;
static char    *interface[2] ;
typedef struct {
		XtArgVal label;
		XtArgVal selectproc ;
		XtArgVal unselectproc ;
		XtArgVal clientdata ;

		} FlatItems;
FlatItems Item[MAXPRE];
String FlatFields[] = {
			XtNlabel,
			XtNselectProc,
			XtNunselectProc,
			XtNclientData,

			};
typedef struct {
		XtArgVal label;
		XtArgVal selectproc ;
		XtArgVal unselectproc ;
		XtArgVal clientdata ;

		} FlatItems1;
FlatItems Item1[MAXSTAT];
String FlatFields1[] = {
			XtNlabel,
			XtNselectProc,
			XtNunselectProc,
			XtNclientData,

			};
typedef struct _im_style {
    char    *label ;
    XIMStyle style ;
} im_style_t ;

static im_style_t pre[5];
static im_style_t status[5];

char    *dicedit_name[3] ;
static XrmDatabase	cmdlines;
static XrmDatabase	rdb ;

#define	EXPECTED_RES_NAME_LEN	32
static int	cmdname_len;
static int	max_xrm_len = EXPECTED_RES_NAME_LEN;

static int	luc_row_def, luc_col_def;
void httprops_notify_htt();

static char           *
GetStringDefaultOfDisplay(display, inst_name, class_name, Default)
    Display	*display ;
    char        *inst_name, *class_name;
    char        *Default;
{
    char	*str_type[20];
    XrmValue    val;
    int		new_len;
    char	*p;
    int         cmdname_len = strlen(htt->command_name);
    char       *xrm_inst_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
    char       *xrm_class_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);

    strcpy(xrm_inst_name, htt->command_name);
    strcat(xrm_inst_name, ".");
    strcpy(xrm_class_name, htt->class_name);
    strcat(xrm_class_name, ".");
    

    new_len = strlen(inst_name); 
    if( new_len > max_xrm_len ) {
	xrm_inst_name = (char *)realloc((void *)xrm_inst_name,
				 		cmdname_len + new_len + 2 );
	xrm_class_name = (char *)realloc((void *)xrm_class_name,
				 		cmdname_len + new_len + 2 );
	max_xrm_len = new_len;
    }
    p = xrm_inst_name + cmdname_len + 1;
    strcpy(p, inst_name);
    p = xrm_class_name + cmdname_len + 1;
    strcpy(p, class_name);

    if(XrmGetResource(rdb, xrm_inst_name, xrm_class_name, str_type, &val))
	return (char *)val.addr;
    else
	return Default;
}

static XrmDatabase GetAppDefaults()
{
    char	*getenv();
    XrmDatabase xrdb;
    char	def_search_path[MAXPATHLEN];
    char        *basepath = getenv("OPENWINHOME");

    if(!basepath)
	basepath="/usr/openwin" ;

    while (htt->core->locale_name == NULL)
	sleep(1);

    sprintf(def_search_path, "%s/lib/locale/%s/app-defaults/htt",
	 basepath,htt->core->locale_name);
    if (access(def_search_path, R_OK)) {
	sprintf(def_search_path, "%s/lib/locale/%s/app-defaults/Htt", 
	basepath, htt->core->locale_name);
    }
    xrdb = XrmGetFileDatabase(def_search_path);
    
    return (xrdb);
}

void
htt_bindtextdomain(display)
Display	*display ;
{
#ifndef SVR4
#define dgettext(a,b) b
#endif
    static char	*default_locale_name = "C";
    char        *getenv(),make_path[MAXPATHLEN];   /* <sys/param.h> */
    char        *domainpath, *message_locale;
    char	   *res_string;
    
    res_string = XResourceManagerString(display);
    rdb = GetAppDefaults();
    if(res_string)
	XrmMergeDatabases(XrmGetStringDatabase(res_string), &rdb);
#ifdef SVR4
    domainpath = GetStringDefaultOfDisplay(display, "textDomain",
					   "TextDomain",(char *)NULL);
    if(!domainpath) 
	domainpath = getenv("HTTMESSAGE");
    if(!domainpath){
	domainpath = getenv("OPENWINHOME");
	sprintf(make_path, "%s/lib/locale", domainpath);
	domainpath = &make_path[0];
    }
    if(domainpath){ 
	char *setdomainpath = NULL;
	setdomainpath = bindtextdomain("SUNW_XIM_HTT_MSG",domainpath);
#ifdef  DEBUG
	if(setdomainpath)
	    (void)dbg_printf("bindtextdomain passed: %s \n",setdomainpath);
	else
	    (void)dbg_printf("bindtextdomain failed: %s !!\n",domainpath);
#endif  /* DEBUG */
    }
#endif /* SVR4 */
}
void
Init_HttProps(){
#ifndef SVR4
#define dgettext(a,b) b
#endif
    XIMStyleRec[0].name  = dgettext("SUNW_XIM_HTT_MSG","OnTheSpot   & imDisplaysInClient");
    XIMStyleRec[1].name  = dgettext("SUNW_XIM_HTT_MSG","OnTheSpot   & imDisplaysInRoot");
    XIMStyleRec[2].name  = dgettext("SUNW_XIM_HTT_MSG","OnTheSpot   & No Status");
    XIMStyleRec[3].name  = dgettext("SUNW_XIM_HTT_MSG","OnTheSpot   & clientDisplays");
    XIMStyleRec[4].name  = dgettext("SUNW_XIM_HTT_MSG","OverTheSpot & imDisplaysInClient");
    XIMStyleRec[5].name  = dgettext("SUNW_XIM_HTT_MSG","OverTheSpot & imDisplaysInRoot");
    XIMStyleRec[6].name  = dgettext("SUNW_XIM_HTT_MSG","OverTheSpot & No Status");
    XIMStyleRec[7].name  = dgettext("SUNW_XIM_HTT_MSG","OverTheSpot & clientDisplays");
    XIMStyleRec[8].name  = dgettext("SUNW_XIM_HTT_MSG","OffTheSpot  & imDisplaysInClient");
    XIMStyleRec[9].name  = dgettext("SUNW_XIM_HTT_MSG","OffTheSpot  & imDisplaysInRoot");
    XIMStyleRec[10].name = dgettext("SUNW_XIM_HTT_MSG","OffTheSpot  & No Status");
    XIMStyleRec[11].name = dgettext("SUNW_XIM_HTT_MSG","OffTheSpot  & clientDisplays");
    XIMStyleRec[12].name = dgettext("SUNW_XIM_HTT_MSG","RootWindow  & imDisplaysInClient");
    XIMStyleRec[13].name = dgettext("SUNW_XIM_HTT_MSG","RootWindow  & imDisplaysInRoot");
    XIMStyleRec[14].name = dgettext("SUNW_XIM_HTT_MSG","RootWindow  & No Status");
    XIMStyleRec[15].name = dgettext("SUNW_XIM_HTT_MSG","RootWindow  & clientDisplays");
    XIMStyleRec[16].name = dgettext("SUNW_XIM_HTT_MSG","No Preedit  & imDisplaysInClient");
    XIMStyleRec[17].name = dgettext("SUNW_XIM_HTT_MSG","No Preedit  & imDisplaysInRoot");
    XIMStyleRec[18].name = dgettext("SUNW_XIM_HTT_MSG","No Preedit  & No Status");
    XIMStyleRec[19].name = dgettext("SUNW_XIM_HTT_MSG","No Preedit  & clientDisplays");
    props[2].heading = dgettext("SUNW_XIM_HTT_MSG","Lookup choice");
    props[1].heading = dgettext("SUNW_XIM_HTT_MSG","RootWindow");
    props[0].heading = dgettext("SUNW_XIM_HTT_MSG","General Setting");
    option[0] = dgettext("SUNW_XIM_HTT_MSG","root.displaylines:");
    option[1] = dgettext("SUNW_XIM_HTT_MSG","preedit.ncolums:");
    option[2] = dgettext("SUNW_XIM_HTT_MSG","preedit.root.nlines:");
    option[3] = dgettext("SUNW_XIM_HTT_MSG","preedit.off.nlines:");
    feedback[0] = dgettext("SUNW_XIM_HTT_MSG","Keep");
    feedback[1] = dgettext("SUNW_XIM_HTT_MSG","Dim");
    feedback[2] = dgettext("SUNW_XIM_HTT_MSG","Remove");
    lookup[0] = dgettext("SUNW_XIM_HTT_MSG","lookup.nrows:");
    lookup[1] = dgettext("SUNW_XIM_HTT_MSG","lookup.ncolums:");
    lookup[2] = dgettext("SUNW_XIM_HTT_MSG","lookup.offset.x:");
    lookup[3] = dgettext("SUNW_XIM_HTT_MSG","lookup.offset.y:");
    lookup[4] = dgettext("SUNW_XIM_HTT_MSG","lookup.borderwidth:");
    attachborder[0] = dgettext("SUNW_XIM_HTT_MSG","left");
    attachborder[1] = dgettext("SUNW_XIM_HTT_MSG","right");
    attachborder[2] = dgettext("SUNW_XIM_HTT_MSG","top");
    attachborder[3] = dgettext("SUNW_XIM_HTT_MSG","bottom");
    pre[0].label = dgettext("SUNW_XIM_HTT_MSG","onTheSpot");
    pre[1].label = dgettext("SUNW_XIM_HTT_MSG","overTheSpot");
    pre[2].label = dgettext("SUNW_XIM_HTT_MSG","offTheSpot");
    pre[3].label = dgettext("SUNW_XIM_HTT_MSG","rootWindow");
    pre[4].label = dgettext("SUNW_XIM_HTT_MSG","none");
    pre[0].style = XIMPreeditCallbacks ;
    pre[1].style = XIMPreeditPosition ;
    pre[2].style = XIMPreeditArea ;
    pre[3].style = XIMPreeditNothing ;
    pre[4].style = XIMPreeditNone ;
    status[0].label = dgettext("SUNW_XIM_HTT_MSG","imDisplaysInClient");
    status[1].label = dgettext("SUNW_XIM_HTT_MSG","imDisplaysInRootWindow");
    status[2].label = dgettext("SUNW_XIM_HTT_MSG","clientDisplays");
    status[3].label = dgettext("SUNW_XIM_HTT_MSG","none");
    status[0].style = XIMStatusArea ;
    status[1].style = XIMStatusNothing ;
    status[2].style = XIMStatusCallbacks ;
    status[3].style = XIMStatusNone ;
    
    dicedit_name[0] = dgettext("SUNW_XIM_HTT_MSG","udicmtool");

    interface[0] = "cm";
    interface[1] = "xci";
#ifdef notforproducts
    interface[2] = "sj3";
    interface[4] = "canna";
#endif

}
static void
save_original(){
    newvalue = (newvalue_t *)malloc(sizeof(newvalue_t));
    bzero(newvalue, sizeof(newvalue_t));
    original = (original_t *)malloc(sizeof(original_t));
    original->statfeed = htt->core->status_feedback ;
    original->prefeed ;
    original->prefeedback ;
    original->attachedborder ;
    original->lucposition ;
    original->lucnavigation ;
    original->lucstyle = ((LucRec)(htt->core->lookup_info))->style ;
    original->interface ;
    original->movable ;
    original->saveunder ;
    original->norestart ;
    original->nrows = ((LucRec)(htt->core->lookup_info))->nrows ;
    original->ncolumns = ((LucRec)(htt->core->lookup_info))->ncolumns ;
}
Widget lucrows, luccolumns ;
Widget nonex_pre1;
Widget caption_im3, caption_im4;
Widget rb_statfeed[MAXFEEDBACK];
#ifdef standalone
main(argc, argv)
#else
htt_prop_main(argc, argv)
#endif
int             argc;
char           *argv[];
{
    Widget	toplevel,ca,prop, popup,bb,props,base,control ;
    Widget      control1, dicedit, resetHtt, title, tile;
    Widget      upper, lower, footer,nonex_pre,caption_im2;
    Widget      apply,reset, bottom;
    Widget      base3, base4, base5, pre_static, caption_im1;
    Widget      pre_static1, pre_static2 ;
    Widget      caption_im,cap_statfeed, ex_statfeed; 
    Widget	controlarea,textarea, notice, reset_it, cancel_it;
    Widget      cancel_button, quit_button, notice_top;
    Widget      control_top, text_top;
    void	apply_callback(), reset_callback(), rb_statfeed_callback();
    void        resetHtt_callback(),dicedit_callback(),quit_htt_callback();
    void        apply1_callback(), reset1_callback();
    void        quit_top_callback();
    void        button_press_callback(), cancel_it_callback();
    void        lucUseIMWindow_callback();
    void        AddWMProtocolToWidget();
    Arg         wargs[3];
    int         Props_IOErrorHandler();
    int         i, n;
    XtAppContext  app;
    char        buf[10];
    Display	*display;
    int	         screen;
    Pixmap	 iconpixmap;
    Pixmap	 iconmask;
    Atom	 SaveYoursefAtom, WMProtocolsAtom;
    char        *fg_color_arg = (char *)NULL;
    char        *xrm_arg  = "-xrm";
    int          status_feedback;
    
    XrmInitialize();
    XrmParseCommand(&cmdlines, NULL, 0, htt->command_name, &argc, argv);

    OlToolkitInitialize((XtPointer) NULL);
#ifdef SVR4
    OlSetDefaultTextFormat(OL_MB_STR_REP);
#endif
    for(i=0; i<argc; i++) {
	if(!strcmp(argv[i], "-fg")) {
	    argv[i] = xrm_arg;
	    fg_color_arg = (char *)malloc(12 + strlen(argv[i+1]));
	    strcpy(fg_color_arg, "*fontColor:");
	    strcat(fg_color_arg, argv[i+1]);
	    argv[i+1] = fg_color_arg;
	    i++;
	}
    }
    
    toplevel = XtVaAppInitialize(&app, "Htt", (XrmOptionDescList) NULL,
				 0, (Cardinal *) & argc, argv, NULL,
				 XtNiconic, True, 
				 XtNresizeCorners, False,
				NULL);
    if(fg_color_arg)
	free(fg_color_arg);
    
    display = XtDisplay(toplevel);
    screen = DefaultScreen(display);

    htt_bindtextdomain(display);

    Init_HttProps();

    iconpixmap = XCreateBitmapFromData(display,XDefaultRootWindow(display),
				       (char *)htt_icon_bits, htt_icon_width, htt_icon_height);
    iconmask = XCreateBitmapFromData(display,XDefaultRootWindow(display),
				     (char *) htt_icon_mask_bits, htt_icon_mask_width,
				     htt_icon_mask_height);
    XtVaSetValues(toplevel, XtNtitle, dgettext("SUNW_XIM_HTT_MSG", "Htt Props"),
                  NULL); 
    XtVaSetValues(toplevel, XtNiconPixmap,(XtArgVal)iconpixmap,	NULL);
    XtVaSetValues(toplevel, XtNiconMask,(XtArgVal)iconmask, NULL);
    XtVaSetValues(toplevel, XtNiconName,
  	dgettext("SUNW_XIM_HTT_MSG", "IMServer"), NULL);
    
    tile = XtVaCreateManagedWidget("tile", controlAreaWidgetClass,
                                   toplevel, 
                                   XtNlayoutType, OL_FIXEDCOLS,
				   NULL);
    ca = XtVaCreateManagedWidget("ca", controlAreaWidgetClass,
                                 tile,
                                 NULL);
#ifdef AfterMars
    dicedit = XtVaCreateManagedWidget("dic-edit", oblongButtonWidgetClass,
				      ca,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Edit Dictionary"),
				      NULL);
    XtAddCallback(dicedit, XtNselect, dicedit_callback, NULL);
#endif
    resetHtt = XtVaCreateManagedWidget("resetHtt", oblongButtonWidgetClass,
				       ca,
				       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Reset Input Method"),
				       NULL);
    /* NOtice */
    n = 0;
    XtSetArg(wargs[n], XtNemanateWidget, resetHtt); n++;
    notice = XtCreatePopupShell("notice", noticeShellWidgetClass,
				 resetHtt, wargs, n );
    n = 0;
    XtSetArg(wargs[n], XtNtextArea, &textarea); n++;
    XtSetArg(wargs[n], XtNcontrolArea, &controlarea); n++;
    XtGetValues(notice, wargs, n); 
    n = 0;
    XtSetArg(wargs[n], XtNstring,dgettext("SUNW_XIM_HTT_MSG", 
				"Do you really want to Reset?")); n++;
    XtSetValues(textarea, wargs, n); 
    reset_it = XtVaCreateManagedWidget("reset_it", oblongButtonWidgetClass,
				controlarea, 
				XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Reset"),
				NULL);
    cancel_it = XtVaCreateManagedWidget("cancel_it", oblongButtonWidgetClass,
				controlarea, 
				XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Cancel"),
				NULL);
    XtAddCallback(reset_it, XtNselect, resetHtt_callback, NULL);
    XtAddCallback(resetHtt,XtNselect, button_press_callback, notice);

  /* continue with the reset of main program */ 
    base = XtVaCreateManagedWidget("base", rubberTileWidgetClass,
                                   tile,
                                   XtNorientation, OL_VERTICAL,
                                   NULL);
    
    control = XtVaCreateManagedWidget("control", controlAreaWidgetClass,
                                      base,
                                      XtNborderWidth, 1,
				      XtNlayoutType, OL_FIXEDCOLS,
                                      NULL);
    
    control1 = XtVaCreateManagedWidget("control1", controlAreaWidgetClass,
                                       control,
                                       NULL);
    
    bb = XtVaCreateManagedWidget("bb", bulletinBoardWidgetClass,
                                 control1,
                                 NULL);
    
    props = XtVaCreateManagedWidget("props",controlAreaWidgetClass,
				    bb,
				    XtNlayoutType, OL_FIXEDCOLS,
				    XtNalignCaptions, TRUE,
				    XtNvSpace, 5,
				    NULL);
    cap_statfeed = XtVaCreateManagedWidget("cap_statfeed", captionWidgetClass,
					   props,
					   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","InactiveStatusFeedback:"),
					   XtNposition, OL_LEFT,
					   NULL);
    
    ex_statfeed = XtVaCreateManagedWidget("ex_statfeed", exclusivesWidgetClass,
					  cap_statfeed,
					  XtNlayoutType, OL_FIXEDROWS,
					  NULL);
    for (i = 0; i < MAXFEEDBACK; i++) {
        rb_statfeed[i] = XtVaCreateManagedWidget(feedback[i], rectButtonWidgetClass,
						 ex_statfeed,
						 XtNlabel,feedback[i],NULL);
	
    }
    status_feedback=GET_HTT_VALUE(htt,status_feedback);
    if(status_feedback == FEEDBACK_NONE){
             XtVaSetValues(rb_statfeed[0], XtNset, True, NULL);/* Keep */
    } else if (status_feedback == FEEDBACK_UNMAP){
             XtVaSetValues(rb_statfeed[2], XtNset, True, NULL);/* Remove */
    } else {
             XtVaSetValues(rb_statfeed[1], XtNset, True, NULL); /* Dim should be selected as default */
    }

#ifdef AfterMars
    caption_im = XtVaCreateManagedWidget("caption_im", captionWidgetClass,
					 props,
					 XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Preedit Region:"),
					 XtNspace, 14,
					 XtNposition, OL_LEFT,
					 NULL);
    nonex_pre = XtVaCreateManagedWidget("nonex_pre",checkBoxWidgetClass,
					caption_im,
					XtNlabel,dgettext("SUNW_XIM_HTT_MSG", "Use IM Server Window"),
					XtNposition, OL_RIGHT,
					XtNset, TRUE,
					NULL);
    
    caption_im1 = XtVaCreateManagedWidget("caption_im1", captionWidgetClass,
					  props,
					  XtNlabel,"  ",
					  XtNposition, OL_LEFT,
					  NULL);
    base3  = XtVaCreateManagedWidget("base3", controlAreaWidgetClass,
				     caption_im1,
				     NULL);
    
    nonex_pre1 = XtVaCreateManagedWidget("nonex_pre1",textFieldWidgetClass,
					 base3,
					 XtNposition, OL_RIGHT,
					 XtNcharsVisible, 4,
					 XtNtextFormat, OL_SB_STR_REP,
					 NULL);
    pre_static = XtVaCreateManagedWidget("pre_static", staticTextWidgetClass,					 base3, 
					 XtNstring, dgettext("SUNW_XIM_HTT_MSG"," lines"),
					 NULL);
#endif
    
    caption_im2 = XtVaCreateManagedWidget("caption_im2", captionWidgetClass,
					  props,
					  XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Input Candidates Display:"),
					  XtNposition, OL_LEFT,
					  XtNspace, 14,
					  NULL);
    
    nonex_pre1 = XtVaCreateManagedWidget("nonex_pre1",checkBoxWidgetClass,
					 caption_im2,
					 XtNlabel,dgettext("SUNW_XIM_HTT_MSG", "Use IM Server Window"),
					 XtNposition, OL_RIGHT,
					 NULL);
    XtAddCallback(nonex_pre1, XtNselect, lucUseIMWindow_callback,True );
    XtAddCallback(nonex_pre1, XtNunselect, lucUseIMWindow_callback, False);

    caption_im3 = XtVaCreateManagedWidget("caption_im3", captionWidgetClass,
					  props,
					  XtNlabel,"  ",
					  XtNposition, OL_LEFT,
					  NULL);
    
    base4  = XtVaCreateManagedWidget("base4", controlAreaWidgetClass,
				     caption_im3,
				     NULL);
    lucrows = XtVaCreateManagedWidget("lucrows",textFieldWidgetClass,
				      base4,
				      XtNposition, OL_RIGHT,
				      XtNcharsVisible, 4,
				      XtNtextFormat, OL_SB_STR_REP,
				      NULL);
    pre_static1 = XtVaCreateManagedWidget("pre_static1", staticTextWidgetClass,					 base4, 
					  XtNstring,dgettext("SUNW_XIM_HTT_MSG", " rows"),
					  NULL);
    
    caption_im4 = XtVaCreateManagedWidget("caption_im4", captionWidgetClass,
					  props,
					  XtNlabel,"  ",
					  XtNposition, OL_LEFT,
					  NULL);
    base5  = XtVaCreateManagedWidget("base5", controlAreaWidgetClass,
				     caption_im4,
				     NULL);
    luccolumns = XtVaCreateManagedWidget("luccolumns",textFieldWidgetClass,
					 base5,
					 XtNposition, OL_RIGHT,
					 XtNcharsVisible, 4,
					 XtNtextFormat, OL_SB_STR_REP,
					 NULL);
    pre_static2 = XtVaCreateManagedWidget("pre_static2", staticTextWidgetClass,	base5, 
					  XtNstring,dgettext("SUNW_XIM_HTT_MSG", " columns"),
					  NULL);
    /*****/
    bottom = XtVaCreateManagedWidget("bottom", controlAreaWidgetClass,
				     control,
				     XtNhPad, 150,
				     XtNvPad, 10,
				     XtNspace, 20,
				     NULL);
    apply = XtVaCreateManagedWidget("apply", oblongButtonWidgetClass,
				    bottom,
				    XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Apply"),
				    NULL);

    reset = XtVaCreateManagedWidget("reset", oblongButtonWidgetClass,
				    bottom,
				    XtNlabel,dgettext("SUNW_XIM_HTT_MSG", "Reset"),
				    NULL);
/* toplevel notice window */

n = 0;
XtSetArg(wargs[n], XtNemanateWidget, tile); n++;
notice_top = XtCreatePopupShell("notice_top", noticeShellWidgetClass,
				  tile, wargs,n);
n = 0;
XtSetArg(wargs[n], XtNtextArea, &text_top); n++;
XtSetArg(wargs[n], XtNcontrolArea, &control_top); n++;
XtGetValues(notice_top, wargs, n);

XtSetArg(wargs[0], XtNstring,dgettext("SUNW_XIM_HTT_MSG","Do you Really want to quit?"));
XtSetValues(text_top, wargs, 1);
quit_button = XtVaCreateManagedWidget("quit_button", oblongButtonWidgetClass,
				control_top, 
				XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Quit"),
				NULL);
cancel_button = XtVaCreateManagedWidget("cancel_button",oblongButtonWidgetClass,
				control_top, 
				XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Cancel"),
				NULL);
/*
 * Quit from the widnow manager. Register this callback so that
 * notice will popup when toplevel shell gets a UM messge to die.
 */
    OlAddCallback(toplevel, XtNwmProtocol, (XtCallbackProc)quit_htt_callback, (XtPointer)notice_top);

/*  This callback is for Quit button in the notice window. */
    XtAddCallback(quit_button, XtNselect, quit_top_callback, NULL);
/*
 * Other callbacks
 */
    XtAddCallback(rb_statfeed[0], XtNselect, rb_statfeed_callback, FEEDBACK_NONE);
    XtAddCallback(rb_statfeed[1], XtNselect, rb_statfeed_callback, FEEDBACK_STIPPLE);     
    XtAddCallback(rb_statfeed[2], XtNselect, rb_statfeed_callback, FEEDBACK_UNMAP);      
    
    XtAddCallback(apply, XtNselect, apply_callback, NULL);
   
    XtAddCallback(reset, XtNselect, reset_callback, NULL);
    
    while(!(htt->core->lookup_info)||((LucRec)(htt->core->lookup_info))->nrows == 0){
	sleep (1);
    }

    luc_row_def = ((LucRec)(htt->core->lookup_info))->nrows;
    luc_col_def = ((LucRec)(htt->core->lookup_info))->ncolumns;

    if(((LucRec)(htt->core->lookup_info))->style == LOOKUP_MENU_IMSWINDOW) {
	XtVaSetValues(nonex_pre1, XtNset, True, NULL);
	XtSetSensitive(caption_im3, False);
	XtSetSensitive(caption_im4, False);
    }
    else {
        sprintf(buf,"%d", luc_row_def);
        XtVaSetValues(lucrows, XtNstring, buf, NULL);
        sprintf(buf,"%d", luc_col_def);
        XtVaSetValues(luccolumns, XtNstring, buf, NULL);
    }

    XtRealizeWidget(toplevel);

    SaveYoursefAtom = XInternAtom(XtDisplay(toplevel),
						"WM_SAVE_YOURSELF", False);
    WMProtocolsAtom = XInternAtom(XtDisplay(toplevel),
						"WM_PROTOCOLS", False);
    AddWMProtocolToWidget(toplevel, SaveYoursefAtom);

    save_original();

    XSetIOErrorHandler(Props_IOErrorHandler);
    
    for(;;) {
	XEvent  event;
	XtAppNextEvent(app, &event);
	if(event.xclient.message_type == WMProtocolsAtom) {
		XClientMessageEvent *cmev = (XClientMessageEvent *)&event;
		if(cmev->data.l[0] == SaveYoursefAtom) {
			XSetCommand(XtDisplay(toplevel), XtWindow(toplevel),
						(char **)NULL, 0);
		}
	}
	XtDispatchEvent(&event);
    }
}
#ifdef standalone
main1(argc, argv)
#else
htt_prop_main1(argc, argv)
#endif
int             argc;
char           *argv[];
{
    int          n, i;
    Arg          wargs[10];
    char         name[8];
    char        *locale ;
    Widget       toplevel, rubber, sl1, sl2, control, delete, caption, caption1;
    Widget       popup, upper, lower, footer, cp1;
    Widget       button, base, label, test, test1, option_base, ex_over, cp_over, option_base1;
    Widget       abbrevmb, main_mp, control1, ex, line_num[MAXOPTIONS], cp[MAXOPTIONS];
    Widget       tile, ca, resetHtt, prop, dicedit, misc, rb_over[MAXOVERS], cp_base1;
    Widget	 cp_luc, rb_luc1, rb_luc2,rb_luc3, ex_luc, line_tf[MAXOPTIONS];
    Widget       nonex_co, nonex_pre[MAXPRE], nonex1_co;
    Widget	 resource_base,check_restart,resource_base1, cap_prefeed;
    Widget	 ex_prefeed,rb_prefeed[MAXFEEDBACK],cp_lookup[MAXLOOKUP];
    Widget       line_con, cap_statfeed, ex_statfeed, rb_statfeed[MAXFEEDBACK];
    Widget       con1_lookup,  line1_con, con2_lookup;
    Widget       resource_basex, button_base, tf1_lookup[MAXLOOKUP];
    Widget	 tf_lookup[MAXLOOKUP],cap_attachborder,cap_lookup, con_lookup;
    Widget	 ex_attachborder, rb_attachborder[MAXBORDER],ex_movable;
    Widget	 rb_movable,ex_saveunder,rb_movable1,rb_saveunder,rb_saveunder1;
    Widget	 rb_lucnavigation, rb_lucnavigation1,ex_lucnavigation;
    Widget	 ex_restart,rb_restart, rb_restart1, misc_cont,menu_pane;
    Widget	 cap_lucnavigation, rb_lucposition, rb_lucposition1;
    Widget	 cap_lucposition,ex_lucposition,rb_interface[MAXINTERFACE];
    Widget	 cap_interface, ex_interface,lookup_saveunder, lookup_movable;
    Widget       rb_pre[MAXPRE], rb_stat[MAXSTAT],nonex_stat[MAXSTAT], button_im;
    Widget       caption_im,caption1_im,popup_im, caption_base ,misc_base, base1;
    Widget	 misc_button, misc_base1,misc_base2,misc_base3,dicedit_button[MAXDIC];
    void         setdefaultlist(/*Widget*/), click_callback(), popup_callback();
    void         deletechoice_callback(), pick_callback(), menu_callback();
    void	 slroot_callback(), rb_over_callback(), dicedit_callback();
    void	 apply_callback(),reset_callback(),popupim_callback();
    void	 rb_interface_callback(), rb_lucnavigation_callback();
    void	 rb_lucposition_callback(), misc_callback(), rb_prefeed_callback(), rb_statfeed_callback();
    void	 rb_luc_callback(), slider_callback(),rb_attachborder_callback();
    void	 resetHtt_callback(),  dicedit_callback();
    void	 rb_saveunder_callback(), rb_movable_callback();
    void	 rb_restart_callback(),lookup_movable_callback(),lookup_saveunder_callback();
    void	 AddWMProtocolToWidget(), nonex_pre_select_callback(),  nonex_pre_unselect_callback();
    void	 nonex_status_select_callback(),  nonex_status_unselect_callback();
    XtAppContext app;
    Display	*display;
    int	         screen;
    Pixmap	 iconpixmap;
    Pixmap	 iconmask;
    Atom	 SaveYoursefAtom, WMProtocolsAtom;
    char        *fg_color_arg = (char *)NULL;
    char        *xrm_arg  = "-xrm";


    static XtCallbackRec apply[] = {
        { (XtCallbackProc)apply_callback, (XtPointer)NULL },
        { NULL, NULL },
    };

    static XtCallbackRec reset[] = {
        { (XtCallbackProc)reset_callback, (XtPointer)NULL },
        { NULL, NULL },
    };

    Init_HttProps();

    OlToolkitInitialize((XtPointer) NULL);
#ifdef SVR4
    OlSetDefaultTextFormat(OL_MB_STR_REP);
#endif
    for(i=0; i<argc; i++) {
	if(!strcmp(argv[i], "-fg")) {
	    argv[i] = xrm_arg;
	    fg_color_arg = (char *)malloc(12 + strlen(argv[i+1]));
	    strcpy(fg_color_arg, "*fontColor:");
	    strcat(fg_color_arg, argv[i+1]);
	    argv[i+1] = fg_color_arg;
	    i++;
	}
    }

    toplevel = XtVaAppInitialize(&app, "HttProps", (XrmOptionDescList) NULL,
				 0, (Cardinal *) & argc, argv, NULL,
				 XtNiconic, True, NULL);
    if(fg_color_arg)
	free(fg_color_arg);

    display = XtDisplay(toplevel);
    screen = DefaultScreen(display);
    iconpixmap = XCreateBitmapFromData(display,XDefaultRootWindow(display),
       (char *)htt_icon_bits, htt_icon_width, htt_icon_height);
    iconmask = XCreateBitmapFromData(display,XDefaultRootWindow(display),
        (char *) htt_icon_mask_bits, htt_icon_mask_width,
        htt_icon_mask_height);

    XtVaSetValues(toplevel, XtNiconPixmap,(XtArgVal)iconpixmap,	NULL);
    XtVaSetValues(toplevel, XtNiconMask,(XtArgVal)iconmask, NULL);
    XtVaSetValues(toplevel, XtNiconName,
        dgettext("SUNW_XIM_HTT_MSG", "IMServer"), NULL);

    tile = XtVaCreateManagedWidget("tile", rubberTileWidgetClass,
				   toplevel, NULL);
    ca = XtVaCreateManagedWidget("ca", controlAreaWidgetClass,
				 tile,
				 NULL);
    resetHtt = XtVaCreateManagedWidget("resetHtt", oblongButtonWidgetClass,
				   ca,
				   XtNlabelType, OL_POPUP,
				   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Reset"),
				   NULL);
    XtAddCallback(resetHtt,XtNselect, resetHtt_callback, NULL);

    prop = XtVaCreateManagedWidget("prop", oblongButtonWidgetClass,
				   ca,
				   XtNlabelType, OL_POPUP,
				   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Properties"),
				   NULL);
#ifdef maybe_after_mars
    dicedit = XtVaCreateManagedWidget("dic-edit", menuButtonWidgetClass,
				   ca,
			           XtNpushpin, OL_OUT,
				   NULL);
    n = 0;
    XtSetArg(wargs[n], XtNmenuPane,&menu_pane); n++;
    XtGetValues(dicedit, wargs, n);
    for(i=0;i<MAXDIC; i++){
	dicedit_button[i] = XtCreateManagedWidget(dicedit_name[i],
						  oblongButtonWidgetClass,
						  menu_pane, NULL,0);
    XtAddCallback(dicedit_button[i], XtNselect,dicedit_callback, dicedit_name[i]);
    }
#else
#ifdef notdef
    if(!strncmp(htt->core->locale_name, "ja", 2) || !strncmp(htt->core->locale_name, "ko", 2)){
    if(!strncmp(setlocale(LC_CTYPE, NULL) "ja", 2) || !strncmp(setlocale(LC_CTYPE,NULL), "ko", 2)){
#endif
	dicedit = XtVaCreateManagedWidget("dic-edit", oblongButtonWidgetClass,
				   ca,
				   XtNlabelType, OL_POPUP,
				   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Dictionary Edit"),
				   NULL);
#ifdef notdef
    } else {
	dicedit = XtVaCreateManagedWidget("dic-edit", oblongButtonWidgetClass,
				   ca,
				   XtNlabelType, OL_POPUP,
         		           XtNsensitive, FALSE,
				   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Dictionary Edit"),
				   NULL);
    }
#endif
    XtAddCallback(dicedit, XtNselect, dicedit_callback, NULL);

#endif

    misc = XtVaCreateManagedWidget("misc", oblongButtonWidgetClass,
				   ca,
				   XtNlabelType, OL_POPUP,
				   XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Misc"),
				   XtNsensitive, FALSE,
				   NULL);

    popup = XtVaCreatePopupShell("popup", popupWindowShellWidgetClass,
				 prop,
				 XtNtitle, dgettext("SUNW_XIM_HTT_MSG","Htt Properties"),
				 XtNapply, apply,
				 XtNreset, reset,
				 NULL);
    XtVaGetValues(popup,
		  XtNupperControlArea, &upper,
		  XtNlowerControlArea, &lower,
		  XtNfooterPanel, &footer,
		  NULL);

    base = XtVaCreateManagedWidget("base", rubberTileWidgetClass,
				   upper,
/*
				   XtNlayoutType, OL_FIXEDCOLS,
 */
				   XtNorientation, OL_VERTICAL,
				   NULL);

    control = XtVaCreateManagedWidget("control", controlAreaWidgetClass,
				      base,
				      NULL);

    control1 = XtVaCreateManagedWidget("control1", controlAreaWidgetClass,
				       base,
				       XtNmeasure, 4,
				       XtNborderWidth, 1,
				       NULL);

    bb = XtVaCreateManagedWidget("bb", bulletinBoardWidgetClass,
				 control1,
				 XtNlayout, OL_MINIMIZE,
				 NULL);
#ifdef mars_beta
    for (i = 0; i < MAXMENUBUTTONS; i++)
#endif
    {
	props[0].co = XtVaCreateWidget(props[i].heading,controlAreaWidgetClass,
				       bb,
				       XtNvSpace, 5,
				       XtNlayoutType, OL_FIXEDCOLS,
				       NULL);
	props[1].co = XtVaCreateWidget(props[i].heading,controlAreaWidgetClass,
				       bb,
				       XtNvSpace, 5,
				       XtNsensitive, FALSE,
				       XtNlayoutType, OL_FIXEDCOLS,
				       NULL);
	props[2].co = XtVaCreateWidget(props[i].heading,controlAreaWidgetClass,
				       bb,
				       XtNvSpace, 5,
				       XtNsensitive, FALSE,
				       XtNlayoutType, OL_FIXEDCOLS,
				       NULL);
    }
    XtManageChild(props[0].co);
    n = 0;
    XtSetArg(wargs[n], XtNstring, dgettext("SUNW_XIM_HTT_MSG","Category:"));
    n++;
    label = XtCreateManagedWidget("label", staticTextWidgetClass,
				  control, wargs, n);
    abbrevmb = XtCreateManagedWidget("abbrevmb",
				     abbrevMenuButtonWidgetClass,
				     control, NULL, 0);
    n = 0;
    XtSetArg(wargs[n], XtNmenuPane, &main_mp);
    n++;
    XtGetValues(abbrevmb, wargs, n);
    n = 0;
    XtSetArg(wargs[n], XtNstring, dgettext("SUNW_XIM_HTT_MSG","General Setting Props:"));
    n++;
    preview = XtCreateManagedWidget("prev", staticTextWidgetClass,
				    control, wargs, n);
    n = 0;
    XtSetArg(wargs[n], XtNpreviewWidget, preview);
    n++;
    XtSetValues(abbrevmb, wargs, n);

    ex = XtVaCreateManagedWidget("ex", exclusivesWidgetClass,
				 main_mp,
				 XtNlayoutType, OL_FIXEDCOLS,
				 NULL);
    for (i = 0; i < MAXMENUBUTTONS; i++) {

	props[i].rb = XtCreateManagedWidget(props[i].heading,
					    rectButtonWidgetClass,
					    ex, NULL, 0);
	XtAddCallback(props[i].rb, XtNselect, menu_callback, &props[i]);
    }
/*********************
 *  Misc panel starts
 ********************/
    misc_base = XtVaCreateManagedWidget("misc_base", controlAreaWidgetClass,
					 props[0].co,
				         XtNlayoutType, OL_FIXEDCOLS,
					 XtNalignCaptions, TRUE,
					 NULL);
    misc_cont = XtVaCreateManagedWidget("misc_cont", controlAreaWidgetClass,
					 props[0].co,
					 XtNhSpace, 10,
					 NULL);

    misc_base1 = XtVaCreateManagedWidget("misc_base1", controlAreaWidgetClass,
					  misc_cont,
				          XtNlayoutType, OL_FIXEDCOLS,
					  NULL);
    misc_base2 = XtVaCreateManagedWidget("misc_base2", controlAreaWidgetClass,
					  misc_cont,
				          XtNlayoutType, OL_FIXEDCOLS,
					  XtNalignCaptions, TRUE,
					  NULL);
/****Preedit style  and STatus Style***/
    caption_im = XtVaCreateManagedWidget("caption_im", captionWidgetClass,
				      misc_base2,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Preedit Style: "),
				      XtNalignment, OL_TOP,
				      XtNposition, OL_LEFT,
				      NULL);
    caption1_im = XtVaCreateManagedWidget("caption1_im", captionWidgetClass,
				       misc_base1,
				       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Status Style:"),
				       XtNalignment, OL_TOP,
				       XtNposition, OL_LEFT,
				       XtNspace, 5,
				       NULL);
    nonex_co = XtVaCreateManagedWidget("nonex_co", controlAreaWidgetClass,
					  caption_im,
				          XtNlayoutType, OL_FIXEDCOLS,
					  NULL);
    for (i = 0; i < MAXPRE; i++){

	nonex_pre[i] = XtVaCreateManagedWidget("nonex_pre",checkBoxWidgetClass,
					nonex_co, 
					XtNlabel, pre[i].label,
					XtNposition, OL_RIGHT,
					XtNset, TRUE,
					NULL);
	XtAddCallback(nonex_pre[i], XtNselect, nonex_pre_select_callback, pre[i].style);
	XtAddCallback(nonex_pre[i], XtNunselect, nonex_pre_unselect_callback, pre[i].style);
    }
#ifdef notdef
    nonex_pre = XtVaCreateManagedWidget("nonex_pre", flatCheckBoxWidgetClass,
					caption_im,
					XtNitems, Item,
					XtNnumItems, MAXPRE,
					XtNitemFields, FlatFields1,
					XtNnumItemFields, XtNumber(FlatFields),
					XtNlayoutType, OL_FIXEDCOLS,
					XtNposition, OL_RIGHT,
					NULL);
#endif
    nonex1_co = XtVaCreateManagedWidget("nonex1_co", controlAreaWidgetClass,
					  caption1_im,
				          XtNlayoutType, OL_FIXEDCOLS,
					  NULL);
    for (i = 0; i < MAXSTAT; i++){
	nonex_stat[i] = XtVaCreateManagedWidget("nonex_stat",checkBoxWidgetClass,
					nonex1_co, 
					XtNlabel, status[i].label,
					XtNposition, OL_RIGHT,
					XtNset, TRUE,
					NULL);
	XtAddCallback(nonex_stat[i], XtNselect, nonex_status_select_callback, status[i].style);
	XtAddCallback(nonex_stat[i], XtNunselect, nonex_status_unselect_callback, status[i].style);
    }
#ifdef notdef
    nonex_stat = XtVaCreateManagedWidget("nonex_stat", flatCheckBoxWidgetClass,
				      caption1_im,
				      XtNitems, Item1,
				      XtNnumItems, MAXSTAT,
				      XtNitemFields, FlatFields1,
				      XtNnumItemFields, XtNumber(FlatFields1),
				      XtNlayoutType, OL_FIXEDCOLS,
                                      XtNset, TRUE,
				      XtNnoneSet, FALSE,
			              XtNposition, OL_RIGHT,
				      NULL);
#endif
/** conversion interface **/
    cap_interface = XtVaCreateManagedWidget("cap_interface", captionWidgetClass,                                          misc_base,
					    XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Conversion Interface:"),
					    XtNsensitive, FALSE,
					    XtNposition, OL_LEFT,
					    NULL);
    ex_interface = XtVaCreateManagedWidget("ex_interface", exclusivesWidgetClass,
					   cap_interface,
					   XtNlayoutType, OL_FIXEDROWS,
					   XtNsensitive, FALSE,
					   NULL);
    for (i = 0; i < MAXINTERFACE; i++) {
	rb_interface[i] = XtVaCreateManagedWidget(interface[i], rectButtonWidgetClass,
						  ex_interface, XtNsensitive, FALSE,
						  NULL);
    }

#ifdef notdef
/*** Preedit Over Mode  ***/
    cp_over = XtVaCreateManagedWidget("cp_over", captionWidgetClass,
				      misc_base,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Preedit over mode:"),
				      XtNposition, OL_LEFT,
				      NULL);
    ex_over = XtVaCreateManagedWidget("ex_over", exclusivesWidgetClass,
				      cp_over,
				      XtNlayoutType, OL_FIXEDROWS,
				      NULL);
    for (i = 0; i < MAXOVERS; i++) {
	rb_over[i] = XtVaCreateManagedWidget(over[i], rectButtonWidgetClass,
					     ex_over, NULL);
    }
#endif

/*** Preedit Feedback Mode ***/
    cap_prefeed = XtVaCreateManagedWidget("cap_prefeed", captionWidgetClass,
					  misc_base,
					  XtNlabel, dgettext("SUNW_XIM_HTT_MSG","PreeditFeedback:"),
					  XtNposition, OL_LEFT,
					  NULL);
    ex_prefeed = XtVaCreateManagedWidget("ex_prefeed", exclusivesWidgetClass,
					 cap_prefeed,
					 XtNlayoutType, OL_FIXEDROWS,
					 NULL);
    for (i = 0; i < MAXFEEDBACK; i++) {
	rb_prefeed[i] = XtVaCreateManagedWidget(feedback[i], rectButtonWidgetClass,
						ex_prefeed, NULL);
     }
/*** Status Feedback Mode ***/
    cap_statfeed = XtVaCreateManagedWidget("cap_statfeed", captionWidgetClass,
					  misc_base,
					  XtNlabel, dgettext("SUNW_XIM_HTT_MSG","StatusFeedback:"),
					  XtNposition, OL_LEFT,
					  NULL);
    ex_statfeed = XtVaCreateManagedWidget("ex_statfeed", exclusivesWidgetClass,
					 cap_statfeed,
					 XtNlayoutType, OL_FIXEDROWS,
					 NULL);
    for (i = 0; i < MAXFEEDBACK; i++) {
	rb_statfeed[i] = XtVaCreateManagedWidget(feedback[i], rectButtonWidgetClass,
						ex_statfeed, NULL);
     }
/*** Restart option **/
    check_restart = XtVaCreateManagedWidget("check_restart",captionWidgetClass,
					    misc_base,
					    XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Restart Option:"),
					    NULL);
    ex_restart = XtVaCreateManagedWidget("ex_restart", exclusivesWidgetClass,
					   check_restart,
					   XtNlayoutType, OL_FIXEDROWS,
					   NULL);
	rb_restart = XtVaCreateManagedWidget("rb_restart", rectButtonWidgetClass,
						  ex_restart,
						  XtNlabel, dgettext("SUNW_XIM_HTT_MSG","ON"),
						  NULL);
	rb_restart1 = XtVaCreateManagedWidget("rb_restart1", rectButtonWidgetClass,
						  ex_restart,
						  XtNlabel, dgettext("SUNW_XIM_HTT_MSG","OFF"),
						  NULL);

    /** button starts */
    misc_base3 = XtVaCreateManagedWidget("misc_base3", controlAreaWidgetClass,
					  props[0].co,
					  XtNcenter, TRUE,
					  NULL);
    button_im = XtVaCreateManagedWidget("button_im", oblongButtonWidgetClass,
					misc_base3,
					XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Detail Setting..."),
					XtNsensitive, FALSE,					
					NULL);
    popup_im = XtVaCreatePopupShell("popup_im", popupWindowShellWidgetClass,
				 button_im,
				 XtNtitle, dgettext("SUNW_XIM_HTT_MSG","Detail Setting for Input Styles"),
				 XtNapply, apply,
				 XtNreset, reset,
				 NULL);
    XtVaGetValues(popup_im,
		  XtNupperControlArea, &upper,
		  XtNlowerControlArea, &lower,
		  XtNfooterPanel, &footer,
		  NULL);
    base1 = XtVaCreateManagedWidget("base1", controlAreaWidgetClass,
				   upper,
				   XtNlayoutType, OL_FIXEDCOLS,
				   NULL);
    caption = XtVaCreateManagedWidget("caption", captionWidgetClass,
				      base1,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Input Style Available"),
				      XtNposition, OL_TOP,
				      XtNalignment, OL_CENTER,
				      NULL);
    caption1 = XtVaCreateManagedWidget("caption", captionWidgetClass,
				       base1,
				       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Exported"),
				       XtNposition, OL_TOP,
				       XtNalignment, OL_CENTER,
				       NULL);
    sl1 = XtVaCreateManagedWidget("sl1", scrollingListWidgetClass,
				   caption,
				   XtNrecomputeWidth, TRUE,
				   XtNviewHeight,10,
				   XtNselectable, FALSE,
				   NULL);
    sl2 = XtVaCreateManagedWidget("sl2", scrollingListWidgetClass,
				  caption1,
				  XtNrecomputeWidth, FALSE,
				  XtNviewHeight, 10,
				  XtNprefMinWidth,265, 
				  XtNselectable, FALSE,
				  NULL);
    button_base = XtVaCreateManagedWidget("button_base", controlAreaWidgetClass,
				   base1,
				   NULL);
    button = XtVaCreateManagedWidget("button", oblongButtonWidgetClass,
				     button_base,
				     XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Delete Your Selection"),
				     NULL);
/************************
 * lookup choice panel
 ***********************/
    resource_basex = XtVaCreateManagedWidget("resource_basex",controlAreaWidgetClass,
					     props[2].co,
					     XtNlayoutType, OL_FIXEDCOLS,
					     NULL);
    resource_base1 = XtVaCreateManagedWidget("resource_base1",controlAreaWidgetClass,
					     resource_basex,
					     XtNlayoutType, OL_FIXEDCOLS,
					     XtNalignCaptions, TRUE,
					     NULL);
    resource_base = XtVaCreateManagedWidget("resource_base",controlAreaWidgetClass,
					     resource_basex,
					     XtNlayoutType, OL_FIXEDCOLS,
					     XtNalignCaptions, TRUE,
					     NULL);
    /***
     *Lookup Menu Number
     **/
    cp_luc = XtVaCreateManagedWidget("cp_luc", captionWidgetClass,
				     resource_base1,
				     XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Lookup Menu:"),
				     XtNposition, OL_LEFT,
				     NULL);
    ex_luc = XtVaCreateManagedWidget("ex_over", exclusivesWidgetClass,
				     cp_luc,
				     XtNlayoutType, OL_FIXEDROWS,
				     NULL);
    rb_luc1 = XtVaCreateManagedWidget("rb_luc1", rectButtonWidgetClass,
				      ex_luc,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Simple Popup"),
				      NULL);
    rb_luc2 = XtVaCreateManagedWidget("rb_luc2", rectButtonWidgetClass,
				      ex_luc,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Gorgeous Popup"),
				      NULL);
    rb_luc3 = XtVaCreateManagedWidget("rb_luc3", rectButtonWidgetClass,
				      ex_luc,
				      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","Root"),
				      NULL);
    /**
     * lookup AttachBorder
     */

    cap_attachborder = XtVaCreateManagedWidget("cap_attachborder", captionWidgetClass,
					       resource_base1,
					       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","lookup.attachedBorder:"),
					       XtNposition, OL_LEFT,
					       NULL);
    ex_attachborder = XtVaCreateManagedWidget("ex_attachborder", exclusivesWidgetClass,
					      cap_attachborder,
					      XtNlayoutType, OL_FIXEDROWS,
					      NULL);
    for (i = 0; i < MAXBORDER; i++) {
	rb_attachborder[i] = XtVaCreateManagedWidget(attachborder[i], rectButtonWidgetClass,
						     ex_attachborder, NULL);
    }
    /**
     * lookup position navigator
     */


    cap_lucposition = XtVaCreateManagedWidget("cap_lucposition", captionWidgetClass,
					      resource_base1,
					      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","lookup.positionNavigator:"),
					      XtNposition, OL_LEFT,
					      NULL);
    ex_lucposition = XtVaCreateManagedWidget("ex_lucposition", exclusivesWidgetClass,
					     cap_lucposition,
					     XtNlayoutType, OL_FIXEDROWS,
					     NULL);
    rb_lucposition = XtVaCreateManagedWidget("rb_lucposition", rectButtonWidgetClass,
					     ex_lucposition,
					     XtNlabel, dgettext("SUNW_XIM_HTT_MSG","mouse"),
					     NULL);
    rb_lucposition1 = XtVaCreateManagedWidget("rb_lucposition1", rectButtonWidgetClass,
					      ex_lucposition,
					      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","window"),
					      NULL);
    /**
     * lookup Naviation
     */

    cap_lucnavigation = XtVaCreateManagedWidget("cap_lucnavigation", captionWidgetClass,
						resource_base1,
						XtNlabel, dgettext("SUNW_XIM_HTT_MSG","lookup.navigation:"),
						XtNposition, OL_LEFT,
						NULL);
    ex_lucnavigation = XtVaCreateManagedWidget("ex_lucnavigation", exclusivesWidgetClass,
					       cap_lucnavigation,
					       XtNlayoutType, OL_FIXEDROWS,
					       NULL);
    rb_lucnavigation = XtVaCreateManagedWidget("rb_lucnavigation", rectButtonWidgetClass,
					       ex_lucnavigation,
					       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","ON"),
					       NULL);
    rb_lucnavigation1 = XtVaCreateManagedWidget("rb_lucnavigation1", rectButtonWidgetClass,
						ex_lucnavigation,
						XtNlabel, dgettext("SUNW_XIM_HTT_MSG","OFF"),
						NULL);
/**
 * lookup movable
 **/
    lookup_movable= XtVaCreateManagedWidget("lookup_movable",captionWidgetClass,
					    resource_base1,
					    XtNlabel, dgettext("SUNW_XIM_HTT_MSG","lookup.movable:"),
					    XtNposition, OL_LEFT,
					    NULL);
    ex_movable = XtVaCreateManagedWidget("ex_movable", exclusivesWidgetClass,
					       lookup_movable,
					       XtNlayoutType, OL_FIXEDROWS,
					       NULL);
    rb_movable = XtVaCreateManagedWidget("rb_movable", rectButtonWidgetClass,
					       ex_movable,
					       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","ON"),
					       NULL);
    rb_movable1 = XtVaCreateManagedWidget("rb_movable1", rectButtonWidgetClass,
						ex_movable,
						XtNlabel, dgettext("SUNW_XIM_HTT_MSG","OFF"),
						NULL);
/**
  * lookup saveunder
  **/
    lookup_saveunder= XtVaCreateManagedWidget("lookup.saveunder",captionWidgetClass,
					      resource_base1,
					      XtNlabel, dgettext("SUNW_XIM_HTT_MSG","lookup.saveunder:"),
					      XtNposition, OL_LEFT,
					      NULL);
    ex_saveunder = XtVaCreateManagedWidget("ex_saveunder", exclusivesWidgetClass,
					       lookup_saveunder,
					       XtNlayoutType, OL_FIXEDROWS,
					       NULL);
    rb_saveunder = XtVaCreateManagedWidget("rb_saveunder", rectButtonWidgetClass,
					       ex_saveunder,
					       XtNlabel, dgettext("SUNW_XIM_HTT_MSG","ON"),
					       NULL);
    rb_saveunder1 = XtVaCreateManagedWidget("rb_saveunder1", rectButtonWidgetClass,
						ex_saveunder,
						XtNlabel, dgettext("SUNW_XIM_HTT_MSG","OFF"),
						NULL);

    cap_lookup = XtVaCreateManagedWidget("cap_lookup", captionWidgetClass,
					 resource_base,
					 XtNlabel,dgettext("SUNW_XIM_HTT_MSG","Lookup Resources:"),
					 XtNposition, OL_LEFT,
                                         XtNalignment, OL_TOP,
					 NULL);
    con_lookup = XtVaCreateManagedWidget("con_lookup", controlAreaWidgetClass,
				          resource_base,
					  NULL);

      con1_lookup = XtVaCreateManagedWidget("con1_lookup",controlAreaWidgetClass,
					        con_lookup,
				                XtNalignCaptions, TRUE,
						XtNvSpace, 22, 
					        XtNlayoutType, OL_FIXEDCOLS,
						NULL);
    for (i = 0; i < MAXLOOKUP; i++) {

	cp_lookup[i] = XtVaCreateManagedWidget(lookup[i], captionWidgetClass,
						con1_lookup,
						XtNposition, OL_LEFT,
					        NULL);
        tf1_lookup[i] = XtVaCreateManagedWidget(lookup[i], textFieldWidgetClass,
					     cp_lookup[i],
				             XtNtextFormat, OL_SB_STR_REP,
					     XtNcharsVisible, 4,
					     NULL);

      }

    con2_lookup = XtVaCreateManagedWidget("con2_lookup", controlAreaWidgetClass,
					        con_lookup,
					        XtNlayoutType, OL_FIXEDCOLS,
						NULL);

    for (i = 0; i < MAXLOOKUP; i++) {

	tf_lookup[i] = XtVaCreateManagedWidget(lookup[i], sliderWidgetClass,
					       con2_lookup,
					       XtNorientation,OL_HORIZONTAL,
					       XtNwidth, 200,
          				       XtNsensitive, FALSE,
					       XtNminLabel, "0",
					       XtNmaxLabel, "10",
					       XtNsliderMax, 10,
			                       XtNtickUnit, OL_PERCENT,
					       XtNticks, 10,
					       XtNgranularity, 10,
					       NULL);
    }

   /************************
    ** root panel
    ************************/
    option_base = XtVaCreateManagedWidget("option_base", controlAreaWidgetClass,
					  props[1].co,
					  NULL);
        line_con = XtVaCreateManagedWidget("line_con", controlAreaWidgetClass,
						option_base, 
					  XtNlayoutType, OL_FIXEDCOLS,
					  XtNalignCaptions, TRUE,
						XtNvSpace, 22, 
						NULL);
    for (i = 0; i < MAXOPTIONS; i++) {
	cp[i] = XtVaCreateManagedWidget(option[i], captionWidgetClass,
					line_con, NULL);
        line_tf[i] = XtVaCreateManagedWidget(option[i], textFieldWidgetClass,
					     cp[i],
				             XtNtextFormat, OL_SB_STR_REP,
					     XtNcharsVisible, 4,
					     NULL);
        }
        line1_con = XtVaCreateManagedWidget("line1_con", controlAreaWidgetClass,
						option_base, 
					        XtNlayoutType, OL_FIXEDCOLS,
						NULL);
    for (i = 0; i < MAXOPTIONS; i++) {
	line_num[i] = XtVaCreateManagedWidget(option[i], sliderWidgetClass,
					      line1_con,
					      XtNorientation, OL_HORIZONTAL,
					      XtNwidth, 200,
					      XtNminLabel, "0",
					      XtNmaxLabel, "10",
					      XtNsliderMax, 10,
					      XtNticks, 10,
					      XtNtickUnit, OL_PERCENT,
					      NULL);
	}

    

    /*I don't know how to use this
      XtSetSensitive(rb_luc2, sensitive);
      */



    n = 0;
    XtSetArg(wargs[n], XtNapplAddItem, &appAdd);
    n++;
    XtSetArg(wargs[n], XtNapplTouchItem, &appTouch);
    n++;
    XtSetArg(wargs[n], XtNapplUpdateView, &appUpdate);
    n++;
    XtSetArg(wargs[n], XtNapplDeleteItem, &appDelete);
    n++;
    XtSetArg(wargs[n], XtNapplViewItem, &appView);
    n++;
    XtGetValues(sl1, wargs, n);
    XtGetValues(sl2, wargs, n);
    XtAddCallback(sl1, XtNuserMakeCurrent, click_callback, sl2);
    XtAddCallback(sl2, XtNuserMakeCurrent, pick_callback, NULL);
    XtAddCallback(button, XtNselect, deletechoice_callback, sl2);
    XtAddCallback(misc, XtNselect, misc_callback, NULL);
    /**
     * slider in root
     **/
    XtAddCallback(line_num[0], XtNsliderMoved, slroot_callback, line_tf[0]);
    XtAddCallback(line_num[1], XtNsliderMoved, slroot_callback, line_tf[1]);
    XtAddCallback(line_num[2], XtNsliderMoved, slroot_callback, line_tf[2]);
    XtAddCallback(line_num[3], XtNsliderMoved, slroot_callback, line_tf[3]);
    /*
     * tf_lookup in window --slider
     */
    XtAddCallback(tf_lookup[0], XtNsliderMoved, slider_callback, tf1_lookup[0]);
    XtAddCallback(tf_lookup[1], XtNsliderMoved, slider_callback, tf1_lookup[1]);
    XtAddCallback(tf_lookup[2], XtNsliderMoved, slider_callback, tf1_lookup[2]);
    XtAddCallback(tf_lookup[3], XtNsliderMoved, slider_callback, tf1_lookup[3]);
#ifdef notdef
    /*
     * rb_over callback
     */
    XtAddCallback(rb_over[0], XtNselect, rb_over_callback, NULL);
    XtAddCallback(rb_over[1], XtNselect, rb_over_callback, NULL);
    XtAddCallback(rb_over[2], XtNselect, rb_over_callback, NULL);
#endif
    /*
     * Lookup Menu
     */
    XtAddCallback(rb_luc1, XtNselect, rb_luc_callback, NULL);
    XtAddCallback(rb_luc2, XtNselect, rb_luc_callback, NULL);
    XtAddCallback(rb_luc3, XtNselect, rb_luc_callback, NULL);
    /*
     * Preedit feedback
     */
    XtAddCallback(rb_prefeed[0], XtNselect, rb_prefeed_callback, FEEDBACK_STIPPLE);
    XtAddCallback(rb_prefeed[1], XtNselect, rb_prefeed_callback, FEEDBACK_UNMAP);
    XtAddCallback(rb_prefeed[2], XtNselect, rb_prefeed_callback, FEEDBACK_NONE);
    /*
     * Status feedback
     */
    XtAddCallback(rb_statfeed[0], XtNselect, rb_statfeed_callback, FEEDBACK_STIPPLE);
    XtAddCallback(rb_statfeed[1], XtNselect, rb_statfeed_callback, FEEDBACK_UNMAP);
    XtAddCallback(rb_statfeed[2], XtNselect, rb_statfeed_callback, FEEDBACK_NONE);
    /*
     *Lookup attatch border
     */
    XtAddCallback(rb_attachborder[0], XtNselect, rb_attachborder_callback, NULL);
    XtAddCallback(rb_attachborder[1], XtNselect, rb_attachborder_callback, NULL);
    XtAddCallback(rb_attachborder[2], XtNselect, rb_attachborder_callback, NULL);
    XtAddCallback(rb_attachborder[3], XtNselect, rb_attachborder_callback, NULL);
    /*
     *Lookup Position Navigator
     */
    XtAddCallback(rb_lucposition, XtNselect, rb_lucposition_callback, NULL);
    XtAddCallback(rb_lucposition1, XtNselect, rb_lucposition_callback, NULL);
    /*
     * Lookup Navigation
     */
    XtAddCallback(rb_lucnavigation, XtNselect, rb_lucnavigation_callback, NULL);
    XtAddCallback(rb_lucnavigation1, XtNselect, rb_lucnavigation_callback, NULL);
    /*
     * rb_interface
     */
    XtAddCallback(rb_interface[0], XtNselect, rb_interface_callback, NULL);
    XtAddCallback(rb_interface[1], XtNselect, rb_interface_callback, NULL);
    /*
     * rb_movable
     */
    XtAddCallback(rb_movable, XtNselect, rb_movable_callback, NULL);
    XtAddCallback(rb_movable1, XtNselect, rb_movable_callback, NULL);
    /*
     * rb_saveunder
     */ 
    XtAddCallback(rb_saveunder, XtNselect, rb_saveunder_callback, NULL);
    XtAddCallback(rb_saveunder1, XtNselect, rb_saveunder_callback, NULL);
    /*
     * check_restart callback
     */
    XtAddCallback(rb_restart, XtNselect, rb_restart_callback, False);/* ON */
    XtAddCallback(rb_restart1, XtNselect, rb_restart_callback, True);/* OFF */


    /**********
     * Set the choices from the original list
     **********/
    setdefaultlist(sl1);
    setdefaultlist(sl2);
    /*****
     * callback for the popup
     */
    XtAddCallback(prop, XtNselect, popup_callback, popup);
    XtAddCallback(button_im, XtNselect, popupim_callback, popup_im);


    XtRealizeWidget(toplevel);

    SaveYoursefAtom = XInternAtom(XtDisplay(toplevel),
						"WM_SAVE_YOURSELF", False);
    WMProtocolsAtom = XInternAtom(XtDisplay(toplevel),
						"WM_PROTOCOLS", False);
    AddWMProtocolToWidget(toplevel, SaveYoursefAtom);
    
    for(;;) {
	XEvent  event;
	XtAppNextEvent(app, &event);
	if(event.xclient.message_type == WMProtocolsAtom) {
		XClientMessageEvent *cmev = (XClientMessageEvent *)&event;
		if(cmev->data.l[0] == SaveYoursefAtom) {
			XSetCommand(XtDisplay(toplevel), XtWindow(toplevel),
						(char **)NULL, 0);
		}
	}
	XtDispatchEvent(&event);
    }
}

void
  AddWMProtocolToWidget(w, atom)
Widget		w;
Atom		atom;
{
    Atom        *get_protocols;
    Atom	*set_protocols;
    int		count, i;
    Bool	found = False;

    XGetWMProtocols(XtDisplay(w), XtWindow(w), &get_protocols, &count);

    set_protocols = (Atom *)malloc((count+1)*sizeof(Atom));
    for(i=0; i<count; i++) {
	set_protocols[i] = get_protocols[i];
	if(get_protocols[i] == atom)
		found = True;
    }
    if(!found) 
	set_protocols[count++] = atom;

    XSetWMProtocols(XtDisplay(w), XtWindow(w), set_protocols, count);
    free(set_protocols);
    XFree(get_protocols);
}


void
  setdefaultlist(sl)
Widget          sl;
{
    int             i;
    OlListItem      item;
    (*appUpdate) (sl, FALSE);
    for (i = 0; i < MAXSTYLES; i++) {
	item.label_type = OL_STRING;
	item.attr = 0;
	item.label = XIMStyleRec[i].name;
	item.mnemonic = NULL;
	XIMStyleRec[i].token = (*appAdd) (sl, 0, 0, item);
    }
    (*appUpdate) (sl, TRUE);
}
void
  menu_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    Arg             warg[1];
    props_t        *local_variable_props = (props_t *) client_data;
    static props_t *prev_props = &props[0];	/* (;_;) */

    String          label;

    XtVaGetValues(w, XtNlabel, &label, NULL);
    XtSetArg(warg[0], XtNstring, label);
    XtSetValues(preview, warg, 1);
    XtVaSetValues(bb, XtNlayout, OL_IGNORE, NULL);
    XtUnmanageChild(prev_props->co);
    XtVaSetValues(bb, XtNlayout, OL_MINIMIZE, NULL);
    XtManageChild(local_variable_props->co);
    prev_props = local_variable_props;
}

void
  resetHtt_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    htt->core->too_fast_restart_count = 0;

    if(!kill(htt->core->htt_pid, 0))
        kill(htt->core->htt_pid, SIGTERM);
}

void
  dicedit_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    if(fork() == 0){
	execlp("/bin/sh", "-c", dgettext("SUNW_XIM_HTT_MSG","udicmtool")) ;
	exit(-1);
    }
}
void
  misc_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
}

void
  pick_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;

{
    int             i;
    OlListItem      item;
    OlListToken     token = (OlListToken) call_data;
    OlListItem     *newItem = OlListItemPointer(token);
    OlListItem     *lastItem;
    static OlListToken lasttoken = (OlListToken) NULL;
    if (lasttoken == token) {	/* unset current choice */
	newItem->attr &= ~OL_LIST_ATTR_CURRENT;
	(*appTouch) (w, token);
	lasttoken = NULL;
	return;
    }
    if (lasttoken) {
	lastItem = OlListItemPointer(lasttoken);
	if (lastItem->attr & OL_LIST_ATTR_CURRENT)
	  lastItem->attr &= ~OL_LIST_ATTR_CURRENT;
	(*appTouch) (w, lasttoken);
    }
    newItem->attr |= OL_LIST_ATTR_CURRENT;
    (*appTouch) (w, token);
    lasttoken = token;
#ifdef DEBUG
    printf("Selected %s\n", newItem->label);
#endif
}
void
  click_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    int             i;
    OlListItem      item;
    OlListToken     token = (OlListToken) call_data;
    OlListToken     token_exported;
    OlListItem     *newItem = OlListItemPointer(token);
    OlListItem     *lastItem;
    static OlListToken lasttoken = (OlListToken) NULL;

    if ((i = search_entry_by_token(token)) < 0) {
	fprintf(stderr, dgettext("SUNW_XIM_HTT_MSG","Unknown token\n"));
	return;
    }
    if (lasttoken == token) {	/* unset current choice */
	newItem->attr &= ~OL_LIST_ATTR_CURRENT;
	(*appTouch) (w, token);
	lasttoken = NULL;
	return;
    }
    if (XIMStyleRec[i].token_exported)
      return;
    if (lasttoken) {
	lastItem = OlListItemPointer(lasttoken);
	if (lastItem->attr & OL_LIST_ATTR_CURRENT)
	  lastItem->attr &= ~OL_LIST_ATTR_CURRENT;
	(*appTouch) (w, lasttoken);
    }
    newItem->attr |= OL_LIST_ATTR_CURRENT;
    (*appTouch) (w, token);
    lasttoken = token;
#ifdef DEBUG
    printf("Selected %s\n", newItem->label);
#endif
    item.label_type = OL_STRING;
    item.attr = 0;
    item.label = newItem->label;
    item.mnemonic = NULL;
    token_exported = (*appAdd) (client_data, 0, 0, item);
    XIMStyleRec[i].token_exported = token_exported;
}

search_entry_by_token(token)
OlListToken     token;
{
    register        i;

    for (i = 0; i < MAXSTYLES; i++) {
	if (XIMStyleRec[i].token == token) {
	    return i;
	}
    }
    return -1;
}
void
  deletechoice_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;

{
    register        i;
    Widget          sl = (Widget) client_data;
    OlListToken     token;
    OlListItem     *item;

    for (i = 0; i < MAXSTYLES; i++) {
	if (token = XIMStyleRec[i].token_exported) {
	    item = OlListItemPointer(token);
	    if (item->attr & OL_LIST_ATTR_CURRENT) {
		item->attr &= ~OL_LIST_ATTR_CURRENT;
		(*appDelete) (sl, token);
		XIMStyleRec[i].token_exported = 0;
	    }
	}
    }
}
void
  popupim_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    Widget          popup = (Widget) client_data;
    XtPopup(popup, XtGrabNone);
}

void
  popup_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    Widget          popup = (Widget) client_data;
    XtPopup(popup, XtGrabNone);
}

void
  slroot_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
}
void
  slider_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
  Widget tf = (Widget)client_data;
  

}
void
 button_press_callback(w, client_data, call_data)
 Widget          w;
 XtPointer       client_data, call_data;
{
    Widget notice = (Widget)client_data;
    XtPopup(notice, XtGrabExclusive);

}

void
quit_top_callback(w, client_data, call_data)
    Widget 	w;
    XtPointer   client_data, call_data;
{
    exit(0);
}
void
quit_htt_callback(w, client_data, call_data)
  Widget 	w;
  XtPointer	client_data, call_data;
{
  OlWMProtocolVerify *olwmpv = (OlWMProtocolVerify *)call_data;
  Widget notice = (Widget)client_data;
  if(olwmpv -> msgtype == OL_WM_DELETE_WINDOW){
     XtPopup(notice, XtGrabExclusive);
  } else {
    OlWMProtocolAction(w, olwmpv, OL_DEFAULTACTION);
  }
}

void
  apply_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
	httprops_notify_htt(w);
}

void
httprops_notify_htt(w)
Widget		w;
{
    int i, j,  size=0 ;
    char *nrows, *ncolumns;
    char buf[10];

#ifdef AfterMars
    for(i=0, htt->core->nstyles=0; i<MAXSTYLES;i++){
	if(XIMStyleRec[i].svalid && XIMStyleRec[i].pvalid){
	    htt->core->styles[htt->core->nstyles++] = XIMStyleRec[i].style ;
	}
    }
    for(i= htt->core->nstyles; i<MAXSTYLES;i++){
	htt->core->styles[i]= 0 ;
    }
    if(newvalue->is_saveunder_changed){
	htt->core->saveunder = newvalue->saveunder ;
	newvalue->is_saveunder_changed = False ;
    }
    if(newvalue->is_norestart_changed){
	htt->core->norestart = newvalue->norestart ;
	newvalue->is_norestart_changed = False ;
    }
    if(newvalue->is_prefeed_changed){
	htt->core->preedit_feedback = newvalue->prefeed ;
	newvalue->is_prefeed_changed = False ;
    }
#endif
    if(newvalue->is_statfeed_changed){
	htt->core->status_feedback = newvalue->statfeed ;
	newvalue->is_statfeed_changed = False ;
    }
    nrows   = OlTextFieldGetString((TextFieldWidget)lucrows, &size);
    for(i=0, j= 0;i<size - 1;i++) {
	if(j > MAXROWS || isdigit(nrows[i]) == 0) {
	    j = ((LucRec)(htt->core->lookup_info))->nrows;
	    sprintf(buf,"%d", j);
	    XtVaSetValues(lucrows, XtNstring, buf, NULL);
	    break ;
	}
	j = j*10 + (nrows[i]-'0');
    }
    if(((LucRec)(htt->core->lookup_info))->nrows != (Dimension)j){
	((LucRec)(htt->core->lookup_info))->nrows = (Dimension)j;
	htt->biff |= LUCNROWS ;
    }
    ncolumns = OlTextFieldGetString((TextFieldWidget)luccolumns, &size);
    for(i=0, j=0;i< size - 1;i++) {
	if(j > MAXCOLUMNS || isdigit(ncolumns[i]) == 0) {
	    j = ((LucRec)(htt->core->lookup_info))->ncolumns;
	    sprintf(buf,"%d", j );
	    XtVaSetValues(luccolumns, XtNstring, buf, NULL);
	    break ;
	}
	j = j*10 + (ncolumns[i]-'0');
    }
    if(((LucRec)(htt->core->lookup_info))->ncolumns != (Dimension) j){
	((LucRec)(htt->core->lookup_info))->ncolumns = (Dimension) j ;
	htt->biff |= LUCNCOLUMNS ;
    }
    if(newvalue->is_lucstyle_changed){
	((LucRec)(htt->core->lookup_info))->style = newvalue->lucstyle ;
	htt->biff |= LUCSTYLE ;
    }
    if(htt->core->htt_pid) {
	XEvent    ev;
	Display   *display = GET_HTT_VALUE(htt, display);
	ev.xclient.type           = ClientMessage;
	ev.xclient.display        = display;
	ev.xclient.window = GET_HTT_VALUE(htt, root_client_wid);
	ev.xclient.message_type   = GET_HTT_VALUE(htt, IMA_IMPROTOCOL);
	ev.xclient.format = 32;
	ev.xclient.data.l[0]      = XIMP_EXT_SHMEM_UPDATE_NOTIFY;
	ev.xclient.data.l[1]      = NULL;
	ev.xclient.data.l[2]      = NULL;
	ev.xclient.data.l[3]      = NULL;
	ev.xclient.data.l[4]      = NULL;
	XSendEvent(XtDisplay(w),
		GET_HTT_VALUE(htt, root_client_wid),
		False, NoEventMask, &ev);
    }
}
void
  reset_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    char buf[10];

    /* remove the check mark in the checkbox */
    XtVaSetValues(nonex_pre1, XtNset, False, NULL);

    newvalue->is_lucstyle_changed = True;
    newvalue->lucstyle = LOOKUP_MENU_POPUPWINDOW;

    newvalue->is_statfeed_changed = True;
    newvalue->statfeed = FEEDBACK_STIPPLE;

    XtVaSetValues(rb_statfeed[1], XtNset, True, NULL); /* Dim as default */
    XtSetSensitive(caption_im3, True);
    XtSetSensitive(caption_im4, True);

    /* reset to default values */
    sprintf(buf,"%d", luc_row_def);
    XtVaSetValues(lucrows, XtNstring, buf, NULL);
    sprintf(buf,"%d", luc_col_def);
    XtVaSetValues(luccolumns, XtNstring, buf, NULL);

    /* inform htt process about the reset change */
    httprops_notify_htt(w);
}


void
  rb_over_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
#ifdef DEBUG
    printf("callback\n");
#endif
}
void
  rb_luc_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
#ifdef DEBUG
    printf("callback\n");
#endif
}
void
  rb_statfeed_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_statfeed_changed = True ;
    newvalue->statfeed = (int) client_data ;
}
void
  rb_prefeed_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_prefeed_changed = True ;
    newvalue->prefeedback = (int) client_data ;
}
void
  rb_attachborder_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_attachedborder_changed = True ;
    newvalue->attachedborder = (Bool) client_data ;
}
void
  rb_lucposition_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_lucposition_changed = True ;
    newvalue->lucposition = (Bool) client_data ;
}
void
  rb_lucnavigation_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_lucnavigation_changed = True ;
    newvalue->lucnavigation = (Bool) client_data ;
}
void
  rb_interface_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_interface_changed = True ;
    newvalue->interface = (Bool) client_data ;
}

void
  rb_movable_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_movable_changed = True ;
    newvalue->movable = (Bool) client_data ;
}
void
  rb_saveunder_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_saveunder_changed = True ;
    newvalue->saveunder = (Bool) client_data ;
}
void
  rb_restart_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_norestart_changed = True ;
    newvalue->norestart = (Bool) client_data ;
}
void
  nonex_status_select_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    int i, j ;
    XIMStyle style = (XIMStyle)client_data ;
    newvalue->is_StylesupportList_changed = True;
    for(i=0, j=0; i<MAXSTYLES;i++){
	if(XIMStyleRec[i].style & style){ 
	    XIMStyleRec[i].svalid = True ;
	    j++ ;
	}
    }

}
void
  nonex_status_unselect_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    int i, j ;
    XIMStyle style = (XIMStyle)client_data ;
    newvalue->is_StylesupportList_changed = True;
    for(i=0, j=0; i<MAXSTYLES;i++){
	if(XIMStyleRec[i].style & style){ 
	    XIMStyleRec[i].svalid = False ;
	} else {
	    j++ ;
	}
    }

}
void
  nonex_pre_select_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    int i, j ;
    XIMStyle style = (XIMStyle)client_data ;
    newvalue->is_StylesupportList_changed = True;
    for(i=0, j=0; i<MAXSTYLES;i++){
	if(XIMStyleRec[i].style & style){ 
	    XIMStyleRec[i].pvalid = True ;
	    j++ ;
	}
    }
}
void
  nonex_pre_unselect_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    int i, j ;
    XIMStyle style = (XIMStyle)client_data ;
    newvalue->is_StylesupportList_changed = True;
    for(i=0, j=0; i<MAXSTYLES;i++){
	if(XIMStyleRec[i].style & style){ 
	    XIMStyleRec[i].pvalid = False ;
	} else {
	    j++ ;
	}
    }
}
void
lucUseIMWindow_callback(w, client_data, call_data)
Widget          w;
XtPointer       client_data, call_data;
{
    newvalue->is_lucstyle_changed = True ;
    if(client_data){
	XtSetSensitive(caption_im3, False);
	XtSetSensitive(caption_im4, False);
	newvalue->lucstyle = LOOKUP_MENU_IMSWINDOW;
    } else {
	XtSetSensitive(caption_im3, True);
	XtSetSensitive(caption_im4, True);
	newvalue->lucstyle = LOOKUP_MENU_POPUPWINDOW;
    }
}

int
Props_IOErrorHandler(display)
Display *display;
{
	exit(1);
}
